#!/usr/local/bin/perl5

$path = "/afs/cs.cmu.edu/user/UUUU/.blowback";
$default_mail_domain = "cs.cmu.edu";
$reallyto = "UUUU+approve\@cs.cmu,edu";
$sender = $ARGV[0];
$approved = 0;
$err = 0;
$date = gmtime();

open LOG, ">>$path/log";
print LOG "LocalApprove $sender\n";
print "LocalApprove $sender\n";

# There should be no junk in these, but make sure.
$from = $sender;
$from =~ tr/-a-zA-Z0-9+@._//dc;
$from =~ tr/A-Z/a-z/;
$to = $reallyto;
$to =~ tr/-a-zA-Z0-9+@._//dc;
$to =~ tr/A-Z/a-z/;
# Where to deliver it?
$_ = $to;
if ( /^(\S+)\+(approve\S*)\@(\S+)$/ ) {
  ($mailbox, $subbox, $maildomain) = /^(\S+)\+(approve\S*)\@(\S+)$/;
} else {
  if ( /^(\S+)\+(approve\S*$)/ ) {
    ($mailbox, $subbox) = /^(\S*)\+(approve\S*)$/;
    $maildomain = $default_mail_domain;
  } else {
    print LOG "Error: Invalid recipient address: $to\n";
    print "Error: Invalid recipient address: $to\n";
    exit 0320;
  }
}

# Accept anything from *.edu
#$approved=1 if( $from =~ /\.edu$/ );

# Check whitelist
if( not $approved ) {
  open WHITELIST, "$path/whitelist.txt" or $err=1;
  while ( <WHITELIST> ) {
    tr/-a-zA-Z0-9+@._//dc;
    tr/A-Z/a-z/;
    if ( $_ eq $from ) {
      $approved = 1;
      last;
    }
  }
  close WHITELIST;
  if($err) {
    print LOG "Error: unable to read whitelist\n";
    print "Error: unable to read whitelist\n";
    exit 0252;
  }
  if( $approved ) {
    print "$from already in whitelist.\n";
  }
}

# Add sender to whitelist (if not already approved)
if( not $approved ) {
  open WHITELIST, ">>$path/whitelist.txt" or $err=1;
  print WHITELIST "$sender\n" or $err=1;
  close WHITELIST or $err=1;
  if($err) {
    print LOG "Error: unable to append whitelist\n";
    print "Error: unable to append whitelist\n";
    exit 0251;
  }
  print "$sender appended to whitelist.\n";
}

# Release any queued messages
if( -d "$path/queue/$from" ) {
  # Read directory
  opendir(DIR, "$path/queue/$from") or $err=1;
  @allfiles = readdir(DIR) or $err=1;
  closedir(DIR) or $err=1;
  if($err) {
    print LOG "Error: unable to read mail queue\n";
    print "Error: unable to read mail queue\n";
    exit 0252;
  }
  $count = 0;
  foreach my $file (@allfiles) {
    next if( $file =~ /^\./ );
    # Read a message
    $message = "";
    open INPUT, "$path/queue/$from/$file" or $err=1;
    while( <INPUT> ) { $message .= $_; }
    close INPUT or $err=1;
    if($err) {
      print LOG "Error: unable to read message $file\n";
      print "Error: unable to read message $file\n";
      exit 0252;
    }
    # Deliver the message
    open ( OUTPUT, "|/afs/cs/user/UUUU/scripts/rdeliver $mailbox" ) or $err=1;
    print OUTPUT "X-blowback: delivered $date\n";
    print OUTPUT $message;
    close OUTPUT or $err=1;
    if ($err) {
      print LOG "Error: Unable to deliver message\n";
      print "Error: Unable to deliver message\n";
      exit 0240;
    }
    print "Delivered message $path/queue/$from/$file\n";
    # Delete the message from the queue
    unlink "$path/queue/$from/$file";
    ++$count;
  }
  rmdir "$path/queue/$from";
  print "Delivered $count messages\n";
} else {
  # No queued messages
  print "no queued messages from $from\n";
}

print LOG "process-approval.perl done\n";
print "process-approval.perl done\n";
close LOG;
exit 0;
