#!/usr/local/bin/perl5

$path = "/afs/cs.cmu.edu/user/UUUU/.blowback";
$default_mail_domain = "cs.cmu.edu";
$phone = "412-268-3069";
$reallyto = $ARGV[0];
$sender = $ARGV[1];
$approved = 0;
$err = 0;
$date = gmtime();

open LOG, ">>$path/log";
print LOG "Approve $reallyto $sender\n";

# There should be no junk in these, but make sure.
$from = $sender;
$from =~ tr/-a-zA-Z0-9+@._//dc;
$from =~ tr/A-Z/a-z/;
$to = $reallyto;
$to =~ tr/-a-zA-Z0-9+@._//dc;
$to =~ tr/A-Z/a-z/;
# Where to deliver it?
$_ = $to;
if ( /^(\S+)\+(approve\S*)\@(\S+)$/ ) {
  ($mailbox, $subbox, $maildomain) = /^(\S+)\+approve(\S*)\@(\S+)$/;
} else {
  if ( /^(\S+)\+(approve\S*$)/ ) {
    ($mailbox, $subbox) = /^(\S*)\+approve(\S*)$/;
    $maildomain = $default_mail_domain;
  } else {
    print LOG "Error: Invalid recipient address: $to\n";
    exit 0320;
  }
}

$now_string = localtime;
print LOG "  mailbox=[$mailbox] maildomain=[$maildomain] time=[$now_string]\n";

# Check subbox token
$answer = crypt($from,"qazwsx");
$answer =~ tr/-a-zA-Z0-9+@._//dc;
$answer =~ tr/A-Z/a-z/;
  if ( $subbox eq $answer ) {
    print LOG "  token: good ($subbox)\n";

    # Check whitelist
    if ( not $approved ) {
      open WHITELIST, "$path/whitelist.txt" or $err=1;
      while ( <WHITELIST> ) {
	tr/-a-zA-Z0-9+@._//dc;
	tr/A-Z/a-z/;
	if ( $_ eq $from ) {
	  $approved = 1;
	  last;
	}
      }
      close WHITELIST;
      if ($err) {
	print LOG "Error: unable to read whitelist\n";
	exit 0252;
      }
    }

    # Add sender to whitelist (if not already approved)
    if ( not $approved ) {
      open WHITELIST, ">>$path/whitelist.txt" or $err=1;
      print WHITELIST "$sender\n" or $err=1;
      close WHITELIST or $err=1;
      if ($err) {
	print LOG "Error: unable to append whitelist\n";
	exit 0251;
      }
    }

    # Release any queued messages
    if ( -d "$path/queue/$from" ) {
      # Read directory
      opendir(DIR, "$path/queue/$from") or $err=1;
      @allfiles = readdir(DIR) or $err=1;
      closedir(DIR) or $err=1;
      if ($err) {
	print LOG "Error: unable to read mail queue\n";
	exit 0252;
      }
      $count = 0;
      foreach my $file (@allfiles) {
	next if( $file =~ /^\./ );
	# Read a message
	$message = "";
	open INPUT, "$path/queue/$from/$file" or $err=1;
	while ( <INPUT> ) {
	  $message .= $_;
	}
	close INPUT or $err=1;
	if ($err) {
	  print LOG "Error: unable to read message $file\n";
	  exit 0252;
	}
	# Deliver the message
	open ( OUTPUT, "|/usr/local/bin/rdeliver $mailbox" ) or $err=1;
	print OUTPUT "X-blowback: delivered $date\n";
	print OUTPUT $message;
	close OUTPUT or $err=1;
	if ($err) {
	  print LOG "Error: Unable to deliver message\n";
	  exit 0240;
	}
	# Delete the message from the queue
	unlink "$path/queue/$from/$file";
	++$count;
	print LOG "  delivered $count queued messages\n";
      }
      rmdir "$path/queue/$from";
    } else {
      # No queued messages
      print LOG "  no queued messages\n";
    }

    # Reply confirmation to sender
    $message = "from: antispam\@$maildomain\n" .
               "to: $from\n" .
	       "reply-to: $to\n" .
	       "date: $date\n" .
	       "subject: confirmation\n\n";
    if ( $approved && $count==0 ) {
      $message .= "Your address ($from) had already been added to the\n'approved' list, " .
	"so all previous messages had already\nbeen delivered to $mailbox.\n\n";
    } else {
      $message .= "Your address ($from) has been added to the 'approved' list,\n" .
	"and $count previous messages were delivered to $mailbox.\n\n";
    }
    $applogline = "good $from $subbox";
  } else {
    print LOG "  token: bad ($subbox != $answer)\n";
    $message = "from: antispam\@$maildomain\n" .
               "to: $from\n" .
	       "reply-to: $to\n" .
	       "date: $date\n" .
	       "subject: confirmation failure\n\n";
    $message .= "I'm sorry, this confirmation process failed. This is probably because\n" .
      "you used a out-of-date confirmation address.  Please try sending\n" .
      "your original message again.  If all else fails, call me at $phone.\n\n";
    $applogline = "bad  $from $subbox";
  }

  $found = 0;
  open APPLOG, "$path/approvals.log" or $err=1;
  while ( <APPLOG> ) {
    chomp;
    if( $_ eq $applogline ) {
      $found = 1;
      print LOG "  found in approvals.log\n";
      last;
    }
  }
  close APPLOG;
  if( $found==0 ) {
    open APPLOG, ">>$path/approvals.log" or $err=1;
    print APPLOG "$applogline\n" or $err=1;
    close APPLOG or $err=1;

    use Net::SMTP;
    $smtp = Net::SMTP->new('localhost');
    $smtp->mail("");
    $smtp->to($sender);
    $smtp->data();
    $smtp->datasend($message);
    $smtp->dataend();
    $smtp->quit();
  }
  if( $err ) {
    print LOG "  Error accessing approvals.log\n";
  }

  print LOG "  process-approval.perl done\n";
  close LOG;
  exit 0;
